﻿using System;
using System.IO;
using System.Threading;
using CSPLibNET;

namespace SmartIdClient {
    public static class SimpleTest {
        public static void Run() {
            // SignTest();
            SignWithEncryptCertTest();
        }

        public static void SignTest() {
            const string passForRemoteKey = "P12345678!";

            var data = File.ReadAllBytes( "..\\..\\..\\UserData\\doc.pdf" );

            var signCert = File.ReadAllBytes("..\\..\\..\\UserData\\010000000000000000000000000000000789cd5d.crt");

            var hashB64 = Convert.ToBase64String( Common.CreateHash( data ) );

            var info = CSP.GetCertificateInfo( signCert );

            Common.PostCmd_RequestDoOperations( passForRemoteKey, info.subjectKeyIdentifier, hashB64, out var ret );

            var ret2 = new ResponseDoOperationsResult( ErrorCode.RequestProcessing );

            while( ret2 != null && ret2.ErrorCode == ErrorCode.RequestProcessing ) {
                Common.PostCmd_RequestDoOperationsResult( ret.RequestId, info.subjectKeyIdentifier, out ret2 );

                if( (int)ret2.ErrorCode > (int)ErrorCode.RequestProcessing ) {
                    return;
                }
                Thread.Sleep( 100 );
            }

            var response = Convert.FromBase64String( ret2.SetSignatures[info.subjectKeyIdentifier]
                                                         .SignData[0].Signature );

            var res = CSP.VerifyExternalData( data, response, signCert );
        }

        public static void SignWithEncryptCertTest() {
            const string passForRemoteKey = "P12345678!";

            var data = File.ReadAllBytes( "..\\..\\..\\UserData\\doc.pdf" );

            var signCert = File.ReadAllBytes("..\\..\\..\\UserData\\010000000000000000000000000000000789cd5d.crt");

            var hashB64 = Convert.ToBase64String( Common.CreateHash( data ) );

            var info = CSP.GetCertificateInfo( signCert );

            Common.GetCert( out var cert, out var key, out var keypass );

            Common.PostCmd_RequestGetEncryptCert( out var certResp );

            var certCrypt = Convert.FromBase64String( certResp.Data );

            Common.PostCmd_RequestDoOperationsCrypt( passForRemoteKey, info.subjectKeyIdentifier, hashB64, certCrypt,
                cert, key,
                keypass, out var ret );

            var ret2 = new ResponseDoOperationsResult( ErrorCode.RequestProcessing );

            while( ret2.ErrorCode == ErrorCode.RequestProcessing ) {
                Common.PostCmd_RequestDoOperationsResult( ret.RequestId, info.subjectKeyIdentifier, out ret2 );

                if( (int)ret2.ErrorCode > (int)ErrorCode.RequestProcessing ) {
                    return;
                }
                Thread.Sleep( 100 );
            }

            var response = Convert.FromBase64String( ret2.SetSignatures[info.subjectKeyIdentifier]
                                                         .SignData[0].Signature );

            var result = CSP.VerifyExternalData( data, response, signCert );
        }
    }
}
